//////////////////////////////////////////////////////
/////
////	Optima++ class; tested with Optima++ 1.5
///
//	You may use this source code in any way you like;
//	it has been tested, but may still contain errors.
// 	In any case, its up to the user to make shure this
//	source works correctly for his/her purpose.
// 	In case you have questions concerning the file i/o used, 
//	look at the documentation	for the clib, or email me
//	at mlenzing@aol.com. If you find errors, please mail me
//	so I can correct them in my files and repost the updated files.
//	

#ifndef __OPP_WFLAGGERHPP
#define __OPP_WFLAGGERHPP

#include <wpch.hpp>

////
// flagging class, simply stores bit flags.

class WCMCLASS WFlagger
{
public:
	WFlagger(WULong flags = 0)
		{ m_Flag = 0; };
	virtual ~WFlagger()
		{};
		
	void SetFlag(WULong flag)
		{ m_Flag |= flag; };
		
	void ClearFlag(WULong flag)
		{ m_Flag &= ~flag; };
		
	WBool GetFlag(WULong flag)
		{ return (WBool) (m_Flag & flag); };
			
	WBool ChangeFlag(WULong flag)
		{ 
			return (WBool) (
					m_Flag = 	m_Flag & flag ? 
						m_Flag & (~flag) 
						: 
						m_Flag | flag
						); 
		};
		
	void Set(WULong flag)
		{ m_Flag = flag; };
		
	void Clear()
		{ m_Flag = 0; };
		
	protected:
		WULong m_Flag;
};


#endif
